local shortName,N = ...
----------------
-- File globals
----------------
local D = LibStub:GetLibrary("DoomCore-2.0")
local updateFrame, setFont = D.updateFrame, D.setFont
N.updateFrame = updateFrame
local Hidden = CreateFrame("FRAME")
Hidden:Hide()
local Addon = D.Addon(shortName, "Conversation", N)
Addon.version = 0.1

local head = Conversation

--------
-- Core
--------

function Addon:OnInitialize()
  self:Register(nil, "Default")

  for _, frameName in pairs{ "QuestFrame", "GossipFrame" } do
    local frame = _G[frameName]
    frame:Hide()
    frame:SetAttribute("UIPanelLayout-defined", false)
    UIPanelWindows[frameName] = nil
    frame:SetParent(Hidden)
  end

  -- Apparently rewards are a separate frame with no backdrop??
  hooksecurefunc("QuestInfo_ShowRewards", function()
    QuestInfoRewardsFrame:Hide()
  end)
end

function Addon:OnLoad()
  self:Rebuild()
end


------------------
-- Frames
------------------

function Addon:BuildChoice(choice, conf)
  conf = conf or self.core
  setFont(choice.TextFrame.Text, {
    font = conf.choiceFont,
    fontSize = conf.choiceSize
  })
end

function Addon:Rebuild(info, r, g, b, a)
  if info then self:ConfSet(info, r, g, b, a) end
  local conf = self.core
  head.TextFrame.Progress:GetAnimations():SetDuration(conf.slideSpeed)
  updateFrame(head,conf)
  head:AnchorAlerts(conf)
  setFont(head.NameFrame.Name, {
    font = conf.titleFont,
    fontSize = conf.titleSize
  })
  setFont(head.TextFrame.Text, {
    font = conf.textFont,
    fontSize = conf.textSize
  })
  for i=1,select("#", head.ChoicesFrame:GetChildren()) do
    self:BuildChoice(select(i, head.ChoicesFrame:GetChildren()), conf)
  end
end

function Addon:Close()
  self:Output("Closing")
  head:Close()
end